//************************************************************************************
//**  
//**  File name:     D:\?????? ??????\???11\Flowcode1.c
//**  Generated by:  Flowcode v4.3.6.61
//**  Date:          Wednesday, June 08, 2011 11:52:03
//**  Licence:       Professional
//**  Registered to: 20ACM8
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//Defines for microcontroller
#define MX_AVR
#define MX_TINY
#define MX_EE
#define MX_EE_SIZE 128
#define MX_USI
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 5
#define MX_SPI_SDO 6
#define MX_SPI_SCK 7
#define MX_UART
#define MX_UART_UCSRC
#define MX_UART_D
#define MX_UART_TX 1
#define MX_UART_RX 0
#define MX_MI2C
#define MX_I2C_B
#define MX_I2C_SDA 5
#define MX_I2C_SCL 7
#define MX_PWM
#define MX_PWM_PORT PORTB
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRB
#define MX_PWM_1 3
#define MX_PWM_TRIS2 DDRB
#define MX_PWM_2 4
#define MX_PWMTYPE 1

//Functions
#define F_CPU 20000000UL
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <avr\wdt.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

//Configuration data
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff
#pragma DATA 0x2, 0xff

//?????????? ???????
#include "C:\Program Files\Matrix Multimedia\Flowcode AVR V4\FCD\internals.h"

//Macro function declarations


//Variable declarations
volatile char FCV_FF;
volatile char FCV_AA;
volatile char FCV_SS;


//Defines:
//Error Reading Code For PWM::DefinesCode




//PWM(0): //Macro function declarations

static void FCD_PWM0_Enable(char nIdx);
static void FCD_PWM0_Disable(char nIdx);
static void FCD_PWM0_SetDutyCycle(char nIdx, char nDuty);
static void FCD_PWM0_ChangePeriod(char nPeriodVal, char nPrescalerVal);



//PWM(0): //Macro implementations


static void FCD_PWM0_Enable(char nIdx)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #else
	    #ifndef MX_PWM_CNT
	      #pragma error FCD file error (no MX_PWM_CNT)
	    #endif
	    #if (MX_PWM_CNT < 1)
	      #pragma error FCD file error (MX_PWM_CNT < 1)
	    #endif
	    #if (MX_PWM_CNT > 2)
	      #pragma error FCD file error (MX_PWM_CNT > 2)
	    #endif
	    #ifndef MX_PWM_TRIS1
	      #pragma error FCD file error (no MX_PWM_TRIS1)
	    #endif
	    #ifndef MX_PWM_1
	      #pragma error FCD file error (no MX_PWM_1)
	    #endif
	    #if (MX_PWM_CNT == 2)
	      #ifndef MX_PWM_TRIS2
	        #pragma error FCD file error (no MX_PWM_TRIS2)
	      #endif
	      #ifndef MX_PWM_2
	        #pragma error FCD file error (no MX_PWM_2)
	      #endif
	    #endif
	    #if (0 == 1)
	      #ifndef MX_PWM_TRIS1a
	        #pragma error PWM component error (using alternative, but no MX_PWM_TRIS1a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	      #ifndef MX_PWM_1a
	        #pragma error PWM component error (using alternative, but no MX_PWM_1a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	    #endif
	    #if (0 == 2)
	      #ifndef MX_PWM_TRIS2a
	        #pragma error PWM component error (using alternative, but no MX_PWM_TRIS2a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	      #ifndef MX_PWM_2a
	        #pragma error PWM component error (using alternative, but no MX_PWM_2a)
	        #define MX_PWM_ALT_ERROR
	      #endif
	    #endif
	  #endif

	  #ifndef MX_PWMTYPE
	    #define MX_PWMTYPE 1
	  #endif

	  #ifdef TCCR1
	    #define MX_TCCR1A TCCR1
	    #define MX_PRESCALE TCCR1
	  #else
	    #define MX_TCCR1A TCCR1A
	    #define MX_PRESCALE TCCR1B
	  #endif

	  #ifndef WGM13VAL
	    #ifdef WGM13					// The presence of WGM13..12 determines the PWM functionality
		  #define WGM13VAL (1<<WGM13)
	    #else
		  #define WGM13VAL 0
	    #endif
	  #endif

	  #ifdef COM10					// AT90S4433 definitions
	    #ifndef COM1A0
		  #define COM1A0	COM10
	    #endif
	    #ifndef COM1A1
		  #define COM1A1	COM11
	    #endif
	  #endif


	#ifdef MX_PWM
	    #ifdef MX_TINY

	      #ifdef OCR1C
	        OCR1C = 255;
	      #else
		    #ifdef ICR1
			ICR1 = 255;
		    #endif
		  #endif

		#else
		  #ifdef ICR1
			ICR1 = 255;
		  #endif
		#endif

	  #if (MX_PWMTYPE == 2)
	    switch (3)
	    {
		  	case 0:
			  	MX_PRESCALE = (MX_PRESCALE & 0xf0);
				break;

			case 1:
	  			MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x02;
				break;

			case 2:
				MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x05;
				break;

			case 3:
				MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x08;
				break;

			case 4:
				MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x0a;
				break;

			case 5:
				MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x0c;
				break;

			case 6:
				MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x0d;
				break;

			case 7:
				MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x0e;
				break;

		    default:
			    MX_PRESCALE = (MX_PRESCALE & 0xf0);
				break;
	  	  }
	  #else
	    MX_PRESCALE = WGM13VAL | (3 & 0x07);
	  #endif

	  #if (MX_PWM_CNT >= 1)
		if (nIdx == 1)
		{
		  #ifdef PWM1A
		      MX_TCCR1A &= ~(1 << COM1A0);
			  MX_TCCR1A |= (1 << COM1A1) | (1 << PWM1A);	// 8-bit PWM timer mode
		  #else
		  	#ifdef WGM13
			  TCCR1A &= ~((1 << COM1A0) | 0x03);	// Select 'clear output on match'
			  TCCR1A |= (1 << COM1A1);				// phase and frequency correct PWM
		    #else
			  TCCR1A &= ~((1 << COM1A0) | 0x02);	// Select 'clear output on match'
			  TCCR1A |= (1 << COM1A1) | 0x01;		// 8-bit PWM timer mode
		    #endif
		  #endif
			set_bit(MX_PWM_TRIS1, MX_PWM_1);
		}
	  #endif

	  #if (MX_PWM_CNT >= 2)
		if (nIdx == 2)
		{
		  #ifdef PWM1B
		    #ifdef TCCR1
		      GTCCR &= ~(1 << COM1B0);
			  GTCCR |= (1 << COM1B1) | (1 << PWM1B);  	  // 8-bit PWM timer mode
			#else
		      MX_TCCR1A &= ~(1 << COM1B0);
			  MX_TCCR1A |= (1 << COM1B1) | (1 << PWM1B);  // 8-bit PWM timer mode
			#endif
		  #else
		    #ifdef WGM13
			  TCCR1A &= ~((1 << COM1B0) | 0x03);	// Select 'clear output on match'
			  TCCR1A |= (1 << COM1B1);				// phase and frequency correct PWM
		    #else
			  TCCR1A &= ~((1 << COM1B0) | 0x02);	// Select 'clear output on match'
			  TCCR1A |= (1 << COM1B1) | 0x01;		// 8-bit PWM timer mode
		    #endif
		  #endif
			set_bit(MX_PWM_TRIS2, MX_PWM_2);
		}
	  #endif
	#endif

	  #ifdef MX_PWM_ALT_ERROR
	    #undef MX_PWM_ALT_ERROR
	  #endif

}

static void FCD_PWM0_Disable(char nIdx)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #endif

	#ifdef MX_PWM
	  #if (MX_PWM_CNT >= 1)
		if (nIdx == 1)
		{
		    MX_TCCR1A &= ~(1 << COM1A1);
		}
	  #endif

	  #if (MX_PWM_CNT >= 2)
		if (nIdx == 2)
		{
		  #ifdef TCCR1
		    GTCCR &= ~(1 << COM1B1);
		  #else
			MX_TCCR1A &= ~(1 << COM1B1);
		  #endif
		}
	  #endif
	#endif

}

static void FCD_PWM0_SetDutyCycle(char nIdx, char nDuty)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #endif

	#ifdef MX_PWM
	  #if (MX_PWM_CNT >= 1)
		if (nIdx == 1)
		{
			OCR1A = nDuty;
		}
	  #endif

	  #if (MX_PWM_CNT >= 2)
		if (nIdx == 2)
		{
			OCR1B = nDuty;
		}
	  #endif
	#endif

}

static void FCD_PWM0_ChangePeriod(char nPeriodVal, char nPrescalerVal)
{
	
	  //error checking
	  #ifndef MX_PWM
	    #warning "This chip does not have PWM capability"
	  #endif

	  #ifdef MX_PWM
	    #ifdef MX_TINY

	      #ifdef OCR1C
	        OCR1C = nPeriodVal;
	      #else
		    #ifdef ICR1
			ICR1 = nPeriodVal;
		    #endif
		  #endif

		#else
		  #ifdef ICR1
			ICR1 = nPeriodVal;
		  #endif
		#endif

		#if (MX_PWMTYPE == 2)
	      switch (nPrescalerVal)
	      {
		  	  case 0:
			  	  MX_PRESCALE = (MX_PRESCALE & 0xf0);
				  break;

			  case 1:
	  			  MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x02;
				  break;

			  case 2:
				  MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x05;
				  break;

			  case 3:
				  MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x08;
				  break;

			  case 4:
				  MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x0a;
				  break;

			  case 5:
				  MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x0c;
				  break;

			  case 6:
				  MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x0d;
				  break;

			  case 7:
				  MX_PRESCALE = (MX_PRESCALE & 0xf0) | 0x0e;
				  break;

		      default:
			      MX_PRESCALE = (MX_PRESCALE & 0xf0);
				  break;
	  	  }
	    #else
	      MX_PRESCALE = WGM13VAL | (nPrescalerVal & 0x07);
	    #endif
	  #endif

}

//Macro implementations

int main()
{
	
	//Initialisation
	MCUCR=0x0a;
	MCUSR=0x00;
	wdt_disable();


	//Interrupt initialisation code
	GIMSK=0x00;


	//??????????
	//??????????:
	//  ff = 255
	FCV_FF = 255;
	

	//??????????
	//??????????:
	//  aa = 1
	FCV_AA = 1;
	

	//?????? ??????????
	//?????? ??????????: PWM(0)::Enable(2)
	FCD_PWM0_Enable(2);


	//?????? ??????????
	//?????? ??????????: PWM(0)::Enable(1)
	FCD_PWM0_Enable(1);


	//?????? ??????????
	//?????? ??????????: PWM(0)::SetDutyCycle(2, 1)
	FCD_PWM0_SetDutyCycle(2, 1);


	//?????? ??????????
	//?????? ??????????: PWM(0)::SetDutyCycle(1, 1)
	FCD_PWM0_SetDutyCycle(1, 1);


	//????????
	//????????: 15 us
	delay_us(15);


	//????
	//????: While 1
	while (1)
	{
		//?????? ??????????
		//?????? ??????????: PWM(0)::Enable(1)
		FCD_PWM0_Enable(1);


		//?????? ??????????
		//?????? ??????????: PWM(0)::Enable(2)
		FCD_PWM0_Enable(2);


		//?????? ??????????
		//?????? ??????????: PWM(0)::SetDutyCycle(1, ff)
		FCD_PWM0_SetDutyCycle(1, FCV_FF);


		//?????? ??????????
		//?????? ??????????: PWM(0)::SetDutyCycle(2, aa)
		FCD_PWM0_SetDutyCycle(2, FCV_AA);


		//????????
		//????????: 1 ??
		delay_ms(1);


		//??????????
		//??????????:
		//  aa = aa+1
		FCV_AA = FCV_AA+1;
		

		//??????????
		//??????????:
		//  ff = ff-1
		FCV_FF = FCV_FF-1;
		

		//???????
		//???????: ff=1?
		if (FCV_FF==1)
		{
			//??????????
			//??????????:
			//  ff = 255
			FCV_FF = 255;
			

		}


		//???????
		//???????: aa=255?
		if (FCV_AA==255)
		{
			//??????????
			//??????????:
			//  aa = 1
			FCV_AA = 1;
			

		}


	}


	mainendloop: goto mainendloop;
}



